
package de.ivu.elect.presentation.wahlvorschlagsperson;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonConversationStore;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonExtendedDAO;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonEdit;
import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson;
import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractWahlvorschlagsPersonEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractWahlvorschlagsPersonEditNoScopeView.VIEW_ID, useCase = UseCasePermission.WAHLVORSCHLAGS_PERSON_EDIT)
public abstract class AbstractWahlvorschlagsPersonEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<WahlvorschlagsPerson>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlvorschlagsPersonEditView";

  public static final String VIEW_ID = "/wahlvorschlagsperson/wahlvorschlags-person-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/wahlvorschlagsperson/wahlvorschlags-person-search.xhtml";

  @Inject
  protected transient WahlvorschlagsPersonExtendedDAO extendedDAO;

  @Inject
  protected transient WahlvorschlagsPersonEdit edit;

  @Inject
  @ConversationGroup(WahlvorschlagsPersonConversationStore.class)
  protected transient WahlvorschlagsPersonConversationStore conversationStore;

  @Inject
  protected transient WahlvorschlagsPersonMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient WahlvorschlagsPersonEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public WahlvorschlagsPerson getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(WahlvorschlagsPerson entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLVORSCHLAGS_PERSON_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(WahlvorschlagsPerson entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLVORSCHLAGS_PERSON_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.WAHLVORSCHLAGS_PERSON_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLVORSCHLAGS_PERSON_EDIT)
  @Override
  public String save() {
    WahlvorschlagsPerson entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(WahlvorschlagsPerson entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    WahlvorschlagsPerson entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(WahlvorschlagsPerson entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.WAHLVORSCHLAGS_PERSON_EDIT);
  }
  
  @Redirect
  public String edit(WahlvorschlagsPerson entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class WahlvorschlagsPersonEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<WahlvorschlagsPerson,  de.ivu.elect.business.person.entity.PersonendatenPK  > {

    private static final long serialVersionUID = 1L;
  }
}
